package com.fjhx.flow.core;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSONObject;
import com.ruoyi.common.utils.SecurityUtils;

import java.util.Date;
import java.util.Map;

public abstract class FlowDelegate {

    public Map<String, Object> initTemplateMap(JSONObject submitData, Object startData) {
        Map<String, Object> map = BeanUtil.beanToMap(submitData);
        map.put("nickName", SecurityUtils.getLoginUser().getUser().getNickName());
        map.put("date", DateUtil.formatDate(new Date()));
        map.put("dateTime", DateUtil.formatDateTime(new Date()));
        map.put("startData", BeanUtil.beanToMap(startData));
        return map;
    }

    /**
     * 开始流程实现类
     *
     * @param flowId 流程id
     * @param data   流程入参
     * @return 业务id
     */
    public abstract Long start(Long flowId, JSONObject data);

    /**
     * 结束流程实现类
     */
    public abstract void end();

}
